// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "Fiber.hpp"

#include <iostream>	 // for operator<<, basic_ostream, ostream, basic_ostrea...

#include "emper-config.h"	 // IWYU pragma: keep

#ifndef EMPER_LOG_OFF
#include <typeinfo>	 // for type_info
#endif

void Fiber::run() const {
	LOGD("run() calling " << function.target<FIBER_FUN_TEMPLATE_ARG>() << " ("
												<< function.target_type().name() << ") with arg " << arg);
	function(arg);
}

auto operator<<(std::ostream& strm, const Fiber& fiber) -> std::ostream& {
	strm << "Fiber [ptr=" << &fiber << " func=" << (fiber.function.target<void(void*)>() != nullptr)
			 << " arg=" << fiber.arg;

	if (fiber.affinity) {
		strm << " aff=" << fiber.affinity;
	} else {
		strm << " aff=nullptr";
	}

	strm << "]";

	return strm;
}

void Fiber::print() const { std::cout << this << std::endl; }
