// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Schmaus
#include "strategies/AbstractWorkStealingStats.hpp"

#include <atomic>
#include <iostream>

#include "strategies/AbstractWorkStealingStrategy.hpp"

AbstractWorkStealingStats::AbstractWorkStealingStats(AbstractWorkStealingStrategy& strategy)
		: scheduledFibersToLocal(strategy.scheduledFibersToLocal),
			scheduledFibersToOverflowQueue(strategy.scheduledFibersToOverflowQueue),
			nextFiberFromLocal(strategy.nextFiberFromLocal),
			nextFiberStolen(strategy.nextFiberStolen),
			nextFiberFromAnywhereQueue(strategy.nextFiberFromAnywhereQueue) {}

void AbstractWorkStealingStats::print() {
	std::cout << "AbstractWorkStealingStats"
						<< " scheduledFibersToLocal:" << scheduledFibersToLocal
						<< " scheduledFibersToOverflowQueue:" << scheduledFibersToOverflowQueue
						<< " nextFiberFromLocal:" << nextFiberFromLocal
						<< " nextFiberStolen:" << nextFiberStolen
						<< " nextFiberFromAnywhereQueue:" << nextFiberFromAnywhereQueue << std::endl;
}
