// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Schmaus
#pragma once

#include <cstdint>

#include "RuntimeStrategyStats.hpp"

class AbstractWorkStealingStrategy;

class AbstractWorkStealingStats : public RuntimeStrategyStats {
 public:
	const uint64_t scheduledFibersToLocal;
	const uint64_t scheduledFibersToOverflowQueue;
	const uint64_t nextFiberFromLocal;
	const uint64_t nextFiberStolen;
	const uint64_t nextFiberFromAnywhereQueue;

	AbstractWorkStealingStats(AbstractWorkStealingStrategy &strategy);

	void print() override;
};
