// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#pragma once

#include "Dispatcher.hpp"
#include "emper-common.h"

class Fiber;
class LawsStrategy;
class Runtime;

class LawsDispatcher : public Dispatcher {
 private:
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wattributes"
	LawsStrategy& lawsStrategy
#ifndef EMPER_STATS
			ATTR_UNUSED
#endif
			;
#pragma GCC diagnostic pop

	void recycle(Fiber* fiber) override;

 public:
	LawsDispatcher(Runtime& runtime, LawsStrategy& lawsStrategy)
			: Dispatcher(runtime), lawsStrategy(lawsStrategy) {}

	void dispatchLoop() override;
};
