// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#pragma once

#include "NextFiberResult.hpp"
#include "emper-common.h"	 // for ATTR_UNUSED
#include "strategies/AbstractWorkStealingScheduler.hpp"

class Fiber;
class Runtime;
class WsStrategy;

class WsScheduler : public AbstractWorkStealingScheduler {
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wattributes"
	WsStrategy& wsStrategy
#ifndef EMPER_STATS
			ATTR_UNUSED
#endif
			;
#pragma GCC diagnostic pop

 protected:
	void scheduleInternal(Fiber& fiber) override { scheduleViaWorkStealing(fiber); }

 public:
	WsScheduler(Runtime& runtime, WsStrategy& wsStrategy);

	auto nextFiber() -> NextFiberResult override { return nextFiberResultViaWorkStealing(); };
};
